## unshield 1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(unshield)

# Mimic CMP0048 which is avaliable only for cmake 3.0 and later
set(PROJECT_VERSION_MAJOR 1)
set(PROJECT_VERSION_MINOR 4)
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")

option(BUILD_STATIC "Build static version of libunshield" OFF)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckCSourceCompiles)
include(GNUInstallDirs)

check_include_files(byteswap.h HAVE_BYTESWAP_H)
check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(memory.h HAVE_MEMORY_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(sys/byteswap.h HAVE_SYS_BYTESWAP_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_function_exists(fnmatch HAVE_FNMATCH)
check_function_exists(iconv HAVE_ICONV)

set(SIZE_FORMAT "zi")
check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_ZI)
if(NOT SIZE_FORMAT_ZI)
	set(SIZE_FORMAT "i")
	check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_I)
	if(NOT SIZE_FORMAT_I)
		set(SIZE_FORMAT "li")
		check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_LI)
		if(NOT SIZE_FORMAT_LI)
			message(FATAL_ERROR "You must be using a really weird platform!")
		endif()
	endif()
endif()

find_package(ZLIB REQUIRED)
find_package(OpenSSL)

if (${OPENSSL_FOUND})
	option(USE_OUR_OWN_MD5 "Build using own md5 implementation" OFF)
else()
	option(USE_OUR_OWN_MD5 "Build using own md5 implementation" ON)
endif()

message(STATUS "OPENSSL_FOUND: ${OPENSSL_FOUND}")
message(STATUS "USE_OUR_OWN_MD5: ${USE_OUR_OWN_MD5}")
message(STATUS "BUILD_STATIC: ${BUILD_STATIC}")

add_definitions(-DHAVE_CONFIG_H)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lib/unshield_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/lib/unshield_config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libunshield.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libunshield.pc @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR}/lib)

# To force position independent code for static libs on Linux x64
if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")
    add_definitions(-fPIC)
endif()

add_subdirectory(lib)
add_subdirectory(src)

install(FILES man/unshield.1 DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/man/man1)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libunshield.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== lib/CMakeLists.txt ===
add_subdirectory(convert_utf)

if(USE_OUR_OWN_MD5)
    add_subdirectory(md5)
endif()

set(LIBUNSHIELD_HEADES
    "internal.h"
    "libunshield.h"
    "log.h"
    "cabfile.h"
)

set(LIBUNSHIELD_SOURCES
    "bswap.c"
    "component.c"
    "directory.c"
    "file.c"
    "file_group.c"
    "helper.c"
    "libunshield.c"
    "log.c"
)

if(BUILD_STATIC)
    set(LIBUNSHIELD_LIBRARY_TYPE STATIC)
else()
    set(LIBUNSHIELD_LIBRARY_TYPE SHARED)
endif()

add_library(libunshield ${LIBUNSHIELD_LIBRARY_TYPE} ${LIBUNSHIELD_HEADES} ${LIBUNSHIELD_SOURCES})

if(USE_OUR_OWN_MD5)
    target_link_libraries(libunshield ${ZLIB_LIBRARY} md5 convert_utf)
else()
    target_link_libraries(libunshield ${ZLIB_LIBRARY} ${OPENSSL_LIBRARIES} convert_utf)
endif()

set_target_properties(libunshield PROPERTIES OUTPUT_NAME unshield)
set_target_properties(libunshield PROPERTIES SOVERSION ${PROJECT_VERSION})

install(TARGETS libunshield RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES libunshield.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

## unshield 0.6

=== debian/changelog ===
unshield (0.6-3) unstable; urgency=low

  * Import patch for new InstallShield versions from Upstream (Closes: #580470)
  * Refresh copyright file
  * Standards-Version: 3.9.3

 -- Evgeni Golov <evgeni@debian.org>  Sat, 03 Mar 2012 15:08:02 +0100

unshield (0.6-2) unstable; urgency=low

  * Fix Vcs-Git field.
  * Drop .la file.
  * Use dh rules.tiny for debian/rules.
  * Standards-Version: 3.9.2.
  * Format 3.0 (quilt).

 -- Evgeni Golov <evgeni@debian.org>  Sat, 30 Apr 2011 12:43:00 +0200

unshield (0.6-1) unstable; urgency=low

  * New upstream release.
  * Switch my e-mail address.
  * Add ${misc:Depends} to Depends of all binary packages, thanks lintian.
  * Bump to debhelper 5, 4 is deprecated.
  * Bump Standards-Version to 3.8.4.
  * Improve libunshield-dev's long description, thanks lintian.
  * Add Vcs-* fields.

 -- Evgeni Golov <evgeni@debian.org>  Fri, 12 Mar 2010 13:56:53 +0100

unshield (0.5.1-1) unstable; urgency=low

  * New maintainer (Closes: #469787)
  * New upstream release (Closes: #350210)
  * debian/control:
    + libunshield-dev should use ${binary:Version} instead of ${Source-Version}
      for depends on libunshield0.
    + Bump Standards-Version to 3.7.3, no changes needed.
    + Build-Depend on automake instead automake1.7.
    + Remove Build-Depend on autoconf.
    + Check spelling. (Closes: #418118)
    + Add a Homepage field.
  * debian/rules:
    + Don't ignore make errors in the clean target.
    + Update config.{sub,guess} on configure, and remove on clean.
    + Don't set CFLAGS, let dpkg handle it.
    + Don't set INSTALL_PROGRAM += -s when no nostrip is found, 
      dh_strip will do this on its own.
    + Install upstream changelog.
  * debian/watch:
    + Update watch-file, it finds upstream releases again now.
  * debian/copyright:
    + List all copyright holders.
    + Use the machine-readable format.
  * debian/{unshield,libunshield0,libundhield-dev}.dirs:
    + Removed the unneeded .dirs files

 -- Evgeni Golov <sargentd@die-welt.net>  Fri, 09 May 2008 08:25:43 +0200

unshield (0.5-3) unstable; urgency=low

  * Added Build-Depends to libtool, autoconf, and automake

 -- Volker Christian <voc@debian.org>  Tue, 13 Sep 2005 18:36:47 +0200

unshield (0.5-2) unstable; urgency=low

  * Fixed conflicts and replacements

 -- Volker Christian <voc@debian.org>  Sat, 10 Sep 2005 21:54:52 +0200

unshield (0.5-1) unstable; urgency=low

  * New upstream release
  * Changed Maintainer-Email to voc@debian.org
  * Updated watch file to conform to version 3
  * Updated the the Policy standard 3.6.2

 -- Volker Christian <voc@debian.org>  Sat, 10 Sep 2005 20:43:24 +0200

unshield (0.4-3) unstable; urgency=low

  * Added --version-info to dh_makeshlibs

 -- Volker Christian <voc@users.sourceforge.net>  Sun, 29 Aug 2004 11:03:38 +0200

unshield (0.4-2) unstable; urgency=low

  * Fixed a ia64 bug in upstream ... patch has to be sent to upstream developer

 -- Volker Christian <voc@users.sourceforge.net>  Mon,  11 Aug 2004 11:55:23 +0200

unshield (0.4-1) unstable; urgency=low

  * New upstream release
  * Added a watch file

 -- Volker Christian <voc@users.sourceforge.net>  Mon,  9 Aug 2004 10:38:54 +0200

unshield (0.3-2) unstable; urgency=low

  * Manual page fixed.

 -- Volker Christian <voc@users.sourceforge.net>  Fri, 10 Jul 2004 20:08:55 +0200

unshield (0.3-1) unstable; urgency=low

  * Initial Release.

 -- Volker Christian <voc@users.sourceforge.net>  Fri, 18 Jun 2004 22:44:05 +0200

=== debian/control ===
Source: unshield
Section: utils
Priority: optional
Maintainer: Evgeni Golov <evgeni@debian.org>
Build-Depends: debhelper (>= 7), zlib1g-dev (>= 1.2.1), libtool (>= 1.4), automake
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 3.9.3
Homepage: http://sourceforge.net/projects/synce
Vcs-Git: git://git.debian.org/git/users/evgeni/unshield.git
Vcs-Browser: http://git.debian.org/?p=users/evgeni/unshield.git

Package: unshield
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extracts CAB files from InstallShield installers
 This software extracts CAB files from InstallShield installers
 used to be installed on Windows CE devices or Windows desktop
 machines.

Package: libunshield0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libunshield
Conflicts: libunshield, liborange
Description: library to extract CAB files from InstallShield installers
 This are libraries to create applications extracting CAB files from
 InstallShield installers used to be installed on Windows CE devices or
 Windows desktop machines.

Package: libunshield-dev
Section: libdevel
Architecture: any
Depends: libunshield0 (= ${binary:Version}), ${misc:Depends} 
Description: development files for libunshield
 This are libraries to create applications extracting CAB files from
 InstallShield installers used to be installed on Windows CE devices or
 Windows desktop machines.
 .
 This package contains the development files needed to link applications
 against libunshield.

=== debian/watch ===
version=3
http://sf.net/synce/ unshield-(.+)\.tar\.gz

## unshield 1.0

=== debian/changelog ===
unshield (1.0-1) unstable; urgency=low

  * New upstream release
   Closes: #721943
   LP: #1221386
   + Does not abort on ARM9 / armv5tel cpu anymore
     Closes: #721933
   + Provides an option to extract selected files
     Closes: #260174
  * update debian/watch for the GitHub move
  * update homepage in debian/copyright and debian/control
  * use dh-autoreconf
  * drop new_installshield_format.patch, it was taken from upstram
  * update Vcs-* fields to new, canonical URLs
  * use dh 9
  * Standards-Version: 3.9.4
  * disable RPATH
  * enable multiarch support
  * update debian/copyright to latest dep3

 -- Evgeni Golov <evgeni@debian.org>  Sat, 07 Sep 2013 18:10:40 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: utils
 Priority: optional
 Maintainer: Evgeni Golov <evgeni@debian.org>
-Build-Depends: debhelper (>= 7), zlib1g-dev (>= 1.2.1), libtool (>= 1.4), automake
+Build-Depends: debhelper (>= 9), zlib1g-dev (>= 1.2.1), dh-autoreconf
 Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 3.9.3
-Homepage: http://sourceforge.net/projects/synce
-Vcs-Git: git://git.debian.org/git/users/evgeni/unshield.git
-Vcs-Browser: http://git.debian.org/?p=users/evgeni/unshield.git
+Standards-Version: 3.9.4
+Homepage: https://github.com/twogood/unshield/
+Vcs-Git: git://anonscm.debian.org/users/evgeni/unshield.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/evgeni/unshield.git
 
 Package: unshield
 Section: utils
@@ -21,7 +21,9 @@
 Package: libunshield0
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Replaces: libunshield
 Conflicts: libunshield, liborange
 Description: library to extract CAB files from InstallShield installers
@@ -32,6 +34,7 @@
 Package: libunshield-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libunshield0 (= ${binary:Version}), ${misc:Depends} 
 Description: development files for libunshield
  This are libraries to create applications extracting CAB files from

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with autoreconf

override_dh_autoreconf:
	dh_autoreconf ./bootstrap

## unshield 1.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -62,10 +62,11 @@
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 include_directories(${CMAKE_CURRENT_BINARY_DIR}/lib)
 
-# To force position independent code for static libs on Linux x64
-if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")
-    add_definitions(-fPIC)
-endif()
+# The POSITION_INDEPENDENT_CODE property was introduced in cmake 2.8.10/CMP0018
+# as we are targeting cmake 2.8.7, we can't use
+#  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+# let's fall back to add_definitions for now
+add_definitions(-fPIC)
 
 add_subdirectory(lib)
 add_subdirectory(src)

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -37,7 +37,7 @@
 endif()
 
 set_target_properties(libunshield PROPERTIES OUTPUT_NAME unshield)
-set_target_properties(libunshield PROPERTIES SOVERSION ${PROJECT_VERSION})
+set_target_properties(libunshield PROPERTIES VERSION 0.0.0 SOVERSION 0)
 
 install(TARGETS libunshield RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES libunshield.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/CMakeLists.txt ===
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
ENDIF("${isSystemDir}" STREQUAL "-1")

add_executable(unshield "unshield.c")
target_link_libraries(unshield libunshield)

add_executable(unshield-deobfuscate "unshield-deobfuscate.c")
target_link_libraries(unshield-deobfuscate libunshield)

install(TARGETS unshield RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== lib/convert_utf/CMakeLists.txt ===
set(LIBCONVERT_UTF_HEADES
    "ConvertUTF.h"
)

set(LIBCONVERT_UTF_SOURCES
    "ConvertUTF.c"
)

add_library(convert_utf STATIC ${LIBCONVERT_UTF_HEADES} ${LIBCONVERT_UTF_SOURCES})

=== lib/md5/CMakeLists.txt ===
set(LIBMD5_UTF_HEADES
	"global.h"
    "md5.h"
)

set(LIBMD5_UTF_SOURCES
    "md5c.c"
)

add_library(md5 STATIC ${LIBMD5_UTF_HEADES} ${LIBMD5_UTF_SOURCES})

=== debian/changelog ===
unshield (1.4.2-1) unstable; urgency=medium

  * New upstream version 1.4.2

 -- Evgeni Golov <evgeni@debian.org>  Sat, 21 Jan 2017 10:27:12 +0100

unshield (1.4.1-1) unstable; urgency=medium

  * New upstream version 1.4.1
  * drop revert-soname-bump.patch, applied upstream

 -- Evgeni Golov <evgeni@debian.org>  Sat, 14 Jan 2017 21:04:11 +0100

unshield (1.4-1) unstable; urgency=medium

  * New upstream release
    Fixes directory traversal issue (CVE-2015-1386)
    Closes: #776193

  [ Alexandre Detiste ]
  * use HTTPS url for Vcs-Git

  [ Evgeni Golov ]
  * update Vcs-* fields to pkg-games
  * add cmake to Build-Depends
  * drop 001-disable-rpath.patch, applied upstream and obsolete
  * do not use dh-autoreconf anymore
  * Standards-Version: 3.9.8
  * Don't duplicate the Section field in d/control
  * don't link OpenSSL even if found
  * revert upstream soname change

 -- Evgeni Golov <evgeni@debian.org>  Mon, 26 Dec 2016 15:47:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: unshield
 Section: utils
 Priority: optional
-Maintainer: Evgeni Golov <evgeni@debian.org>
-Build-Depends: debhelper (>= 9), zlib1g-dev (>= 1.2.1), dh-autoreconf
-Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 3.9.4
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders: Evgeni Golov <evgeni@debian.org>
+Build-Depends: debhelper (>= 9), zlib1g-dev (>= 1.2.1), cmake
+Standards-Version: 3.9.8
 Homepage: https://github.com/twogood/unshield/
-Vcs-Git: git://anonscm.debian.org/users/evgeni/unshield.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/evgeni/unshield.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-games/unshield.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/unshield.git
 
 Package: unshield
-Section: utils
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: extracts CAB files from InstallShield installers

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_OUR_OWN_MD5=YES

=== debian/watch ===
version=3
https://github.com/twogood/unshield/releases /twogood/unshield/archive/(.+)\.tar\.gz

## unshield 1.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,16 @@
 cmake_minimum_required(VERSION 2.8.7)
-project(unshield)
+project(unshield C)
 
 # Mimic CMP0048 which is avaliable only for cmake 3.0 and later
 set(PROJECT_VERSION_MAJOR 1)
-set(PROJECT_VERSION_MINOR 4)
-set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
+set(PROJECT_VERSION_MINOR 5)
+set(PROJECT_VERSION_PATCH 1)
+set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 option(BUILD_STATIC "Build static version of libunshield" OFF)
 
 include(CheckIncludeFiles)
-include(CheckFunctionExists)
+include(CheckSymbolExists)
 include(CheckCSourceCompiles)
 include(GNUInstallDirs)
 
@@ -26,8 +27,8 @@
 check_include_files(sys/stat.h HAVE_SYS_STAT_H)
 check_include_files(sys/types.h HAVE_SYS_TYPES_H)
 check_include_files(unistd.h HAVE_UNISTD_H)
-check_function_exists(fnmatch HAVE_FNMATCH)
-check_function_exists(iconv HAVE_ICONV)
+check_symbol_exists(fnmatch fnmatch.h HAVE_FNMATCH)
+check_symbol_exists(iconv iconv.h HAVE_ICONV)
 
 set(SIZE_FORMAT "zi")
 check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_ZI)
@@ -62,14 +63,24 @@
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 include_directories(${CMAKE_CURRENT_BINARY_DIR}/lib)
 
-# The POSITION_INDEPENDENT_CODE property was introduced in cmake 2.8.10/CMP0018
-# as we are targeting cmake 2.8.7, we can't use
-#  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
-# let's fall back to add_definitions for now
-add_definitions(-fPIC)
+# Function to change MSVC runtime linkage to static
+function(set_msvc_runtime_static)
+    foreach(flag_var
+        CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
+        CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
+        if(${flag_var} MATCHES "/MD")
+            string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
+        endif()
+    endforeach()
+endfunction()
+
+if (MSVC)
+    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/win32_msvc)
+endif ()
 
 add_subdirectory(lib)
 add_subdirectory(src)
 
-install(FILES man/unshield.1 DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/man/man1)
+install(FILES man/unshield.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libunshield.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(libunshield C)

add_subdirectory(convert_utf)

if(USE_OUR_OWN_MD5)
    add_subdirectory(md5)
endif()

set(LIBUNSHIELD_HEADES
    "internal.h"
    "libunshield.h"
    "log.h"
    "cabfile.h"
)

set(LIBUNSHIELD_SOURCES
    "bswap.c"
    "component.c"
    "directory.c"
    "file.c"
    "file_group.c"
    "helper.c"
    "libunshield.c"
    "log.c"
)

if(BUILD_STATIC)
    add_library(${PROJECT_NAME} STATIC ${LIBUNSHIELD_HEADES} ${LIBUNSHIELD_SOURCES})
else()
    add_library(${PROJECT_NAME} SHARED ${LIBUNSHIELD_HEADES} ${LIBUNSHIELD_SOURCES})
endif()

target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} PUBLIC ZLIB::ZLIB convert_utf)
set_target_properties(libunshield PROPERTIES OUTPUT_NAME unshield)
set_target_properties(libunshield PROPERTIES VERSION 0.0.0 SOVERSION 0)

if(USE_OUR_OWN_MD5)
    target_link_libraries(${PROJECT_NAME} PUBLIC md5)
else()
    target_link_libraries(${PROJECT_NAME} PUBLIC OpenSSL::Crypto)
endif()

install(TARGETS libunshield RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES libunshield.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/CMakeLists.txt ===
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif()

add_executable(unshield "unshield.c")
target_link_libraries(unshield libunshield)
if(WIN32)
    if(HAVE_ICONV)
        target_link_libraries(unshield iconv)
    endif()
    target_link_libraries(unshield ${ZLIB_LIBRARIES})
endif()

add_executable(unshield-deobfuscate "unshield-deobfuscate.c")
target_link_libraries(unshield-deobfuscate libunshield)
if(WIN32)
    target_link_libraries(unshield-deobfuscate ${ZLIB_LIBRARIES})
endif()

if(BUILD_STATIC AND MSVC)
    set_msvc_runtime_static()
endif()

install(TARGETS unshield RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== lib/convert_utf/CMakeLists.txt ===
--- 
+++ 
@@ -6,4 +6,17 @@
     "ConvertUTF.c"
 )
 
+if(BUILD_STATIC AND MSVC)
+    set_msvc_runtime_static()
+endif()
+
 add_library(convert_utf STATIC ${LIBCONVERT_UTF_HEADES} ${LIBCONVERT_UTF_SOURCES})
+
+# Linux/Clang-7
+# relocation R_X86_64_32S against `.rodata' can not be used when making a shared object;
+# recompile with -fPIC
+include(CheckCCompilerFlag)
+CHECK_C_COMPILER_FLAG("-fPIC" COMPILER_HAS_FPIC)
+if (COMPILER_HAS_FPIC)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
+endif()

=== lib/md5/CMakeLists.txt ===
--- 
+++ 
@@ -7,4 +7,8 @@
     "md5c.c"
 )
 
+if(BUILD_STATIC AND MSVC)
+    set_msvc_runtime_static()
+endif()
+
 add_library(md5 STATIC ${LIBMD5_UTF_HEADES} ${LIBMD5_UTF_SOURCES})

=== debian/changelog ===
unshield (1.5.1-2) unstable; urgency=medium

  * Team upload
  * Fix build with CMake 4 (Closes: #1113605)
  * Fix build with GCC-15 (Closes: #1098042)
  * update d/watch to v5

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 27 Sep 2025 22:00:00 +0200

unshield (1.5.1-1) unstable; urgency=low

  * Team upload
  * fix d/watch for new Github API
  * New upstream version 1.5.1

  [ Debian Janitor ]
  * Bump debhelper from deprecated 9 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, ...
  * Update Vcs-* headers from URL redirect.
  * Update watch file format version to 4.
  * Fix day-of-week for changelog entries 0.4-2, 0.3-2.
  * Use secure copyright file specification URI.
  * Trim trailing whitespace.

 -- Alexandre Detiste <tchet@debian.org>  Mon, 04 Dec 2023 00:44:55 +0100

=== debian/control ===
Source: unshield
Section: utils
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Evgeni Golov <evgeni@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 zlib1g-dev (>= 1.2.1),
Standards-Version: 3.9.8
Homepage: https://github.com/twogood/unshield/
Vcs-Git: https://salsa.debian.org/games-team/unshield.git
Vcs-Browser: https://salsa.debian.org/games-team/unshield
Rules-Requires-Root: no
X-Style: black

Package: unshield
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: extracts CAB files from InstallShield installers
 This software extracts CAB files from InstallShield installers
 used to be installed on Windows CE devices or Windows desktop
 machines.

Package: libunshield0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Replaces:
 libunshield,
Conflicts:
 liborange,
 libunshield,
Description: library to extract CAB files from InstallShield installers
 This are libraries to create applications extracting CAB files from
 InstallShield installers used to be installed on Windows CE devices or
 Windows desktop machines.

Package: libunshield-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libunshield0 (= ${binary:Version}),
 ${misc:Depends},
Description: development files for libunshield
 This are libraries to create applications extracting CAB files from
 InstallShield installers used to be installed on Windows CE devices or
 Windows desktop machines.
 .
 This package contains the development files needed to link applications
 against libunshield.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_OUR_OWN_MD5=YES -DCMAKE_POLICY_VERSION_MINIMUM=3.5

=== debian/watch ===
Version: 5
Template: Github
Owner: twogood
Project: unshield

## unshield 1.6.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)
project(unshield C)

# Mimic CMP0048 which is avaliable only for cmake 3.0 and later
set(PROJECT_VERSION_MAJOR 1)
set(PROJECT_VERSION_MINOR 6)
set(PROJECT_VERSION_PATCH 2)
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

option(BUILD_STATIC "Build static version of libunshield" OFF)

include(CheckIncludeFiles)
include(CheckSymbolExists)
include(CheckCSourceCompiles)
if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/test")
    include(CTest)
endif()
include(GNUInstallDirs)

check_include_files(dlfcn.h HAVE_DLFCN_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(memory.h HAVE_MEMORY_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(stdlib.h HAVE_STDLIB_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(string.h HAVE_STRING_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_symbol_exists(fnmatch fnmatch.h HAVE_FNMATCH)
check_symbol_exists(iconv iconv.h HAVE_ICONV)

set(SIZE_FORMAT "zi")
check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_ZI)
if(NOT SIZE_FORMAT_ZI)
    set(SIZE_FORMAT "i")
    check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_I)
    if(NOT SIZE_FORMAT_I)
        set(SIZE_FORMAT "li")
        check_c_source_compiles("#include <stdio.h>\nint main(int argc, char **argv) { size_t value = 0; printf(\"%${SIZE_FORMAT}\", value); return 0; }" SIZE_FORMAT_LI)
        if(NOT SIZE_FORMAT_LI)
            message(FATAL_ERROR "You must be using a really weird platform!")
        endif()
    endif()
endif()

find_package(ZLIB REQUIRED)
find_package(OpenSSL)

if(${OPENSSL_FOUND})
    option(USE_OUR_OWN_MD5 "Build using own md5 implementation" OFF)
else()
    option(USE_OUR_OWN_MD5 "Build using own md5 implementation" ON)
endif()

message(STATUS "OPENSSL_FOUND: ${OPENSSL_FOUND}")
message(STATUS "USE_OUR_OWN_MD5: ${USE_OUR_OWN_MD5}")
message(STATUS "BUILD_STATIC: ${BUILD_STATIC}")
if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/test")
    message(STATUS "BUILD_TESTING: ${BUILD_TESTING}")
else()
    set(BUILD_TESTING OFF)
endif()

add_definitions(-DHAVE_CONFIG_H)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lib/unshield_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/lib/unshield_config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libunshield.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libunshield.pc @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR}/lib)

# Function to change MSVC runtime linkage to static
function(set_msvc_runtime_static)
    foreach(flag_var
        CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        if(${flag_var} MATCHES "/MD")
            string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endif()
    endforeach()
endfunction()

if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/win32_msvc)
endif ()

add_subdirectory(lib)
add_subdirectory(src)

install(FILES man/unshield.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libunshield.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(EXPORT unshieldConfig NAMESPACE unshield:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/unshield)

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

=== lib/CMakeLists.txt ===
if(USE_OUR_OWN_MD5)
    add_subdirectory(md5)
endif()

set(LIBUNSHIELD_HEADERS
    internal.h
    libunshield.h
    log.h
    cabfile.h
    converter.h
)

set(LIBUNSHIELD_SOURCES
    component.c
    converter.c
    directory.c
    file.c
    file_group.c
    helper.c
    libunshield.c
    log.c
)

if(BUILD_STATIC)
    add_library(libunshield STATIC ${LIBUNSHIELD_HEADERS} ${LIBUNSHIELD_SOURCES})
else()
    add_library(libunshield SHARED ${LIBUNSHIELD_HEADERS} ${LIBUNSHIELD_SOURCES})
    target_compile_definitions(libunshield PUBLIC UNSHIELD_DYNAMIC_LIBRARY)
endif()

target_include_directories(libunshield PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
target_link_libraries(libunshield PUBLIC ZLIB::ZLIB)
target_compile_definitions(libunshield PRIVATE UNSHIELD_EXPORT)
set_target_properties(libunshield PROPERTIES OUTPUT_NAME unshield)
set_target_properties(libunshield PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

if(USE_OUR_OWN_MD5)
    target_link_libraries(libunshield PRIVATE $<TARGET_OBJECTS:md5>)
else()
    target_link_libraries(libunshield PRIVATE OpenSSL::Crypto)
endif()

install(TARGETS libunshield EXPORT unshieldConfig RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES libunshield.h DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

=== src/CMakeLists.txt ===
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif()

add_executable(unshield unshield.c)
target_link_libraries(unshield libunshield)
if(WIN32)
    if(HAVE_ICONV)
        target_link_libraries(unshield iconv)
    endif()
    target_link_libraries(unshield ${ZLIB_LIBRARIES})
endif()

add_executable(unshield-deobfuscate unshield-deobfuscate.c)
target_link_libraries(unshield-deobfuscate libunshield)
if(WIN32)
    target_link_libraries(unshield-deobfuscate ${ZLIB_LIBRARIES})
endif()

if(BUILD_STATIC AND MSVC)
    set_msvc_runtime_static()
endif()

install(TARGETS unshield EXPORT unshieldConfig RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== lib/md5/CMakeLists.txt ===
set(LIBMD5_HEADERS
    global.h
    md5.h
)

set(LIBMD5_SOURCES
    md5c.c
)

if(BUILD_STATIC AND MSVC)
    set_msvc_runtime_static()
endif()

add_library(md5 OBJECT ${LIBMD5_HEADERS} ${LIBMD5_SOURCES})

=== debian/changelog ===
unshield (1.6.2-2) unstable; urgency=medium

  * Team upload
  * upload to unstable
  * Fix build on hppa (Closes: #1057664)

 -- Sébastien Noel <sebastien@twolife.be>  Thu, 09 Oct 2025 08:56:51 +0200

unshield (1.6.2-1) experimental; urgency=medium

  * Team upload
  * New upstream release
  * SONAME bump: libunshield0 -> libunshield1
  * d/copyright: Update for new upstream release

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 28 Sep 2025 09:09:42 +0200

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,10 @@
  debhelper-compat (= 13),
  cmake,
  zlib1g-dev (>= 1.2.1),
-Standards-Version: 3.9.8
+Standards-Version: 4.7.2
 Homepage: https://github.com/twogood/unshield/
 Vcs-Git: https://salsa.debian.org/games-team/unshield.git
 Vcs-Browser: https://salsa.debian.org/games-team/unshield
-Rules-Requires-Root: no
 X-Style: black
 
 Package: unshield
@@ -25,7 +24,7 @@
  used to be installed on Windows CE devices or Windows desktop
  machines.
 
-Package: libunshield0
+Package: libunshield1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -49,7 +48,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libunshield0 (= ${binary:Version}),
+ libunshield1 (= ${binary:Version}),
  ${misc:Depends},
 Description: development files for libunshield
  This are libraries to create applications extracting CAB files from

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_OUR_OWN_MD5=YES
